public class Algorithms
{
	// swap
	private static void swap(long[] array, int index1, int index2)
	{
		long temp = array[index1];
		array[index1] = array[index2];
		array[index2] = temp;
	}

	private static void swap(int[] array, int index1, int index2)
	{
		int temp = array[index1];
		array[index1] = array[index2];
		array[index2] = temp;
	}

	/* * * * * * * * * * wjƧ * * * * * * * * * */

	public static void bubble_sort(int[] array)
	{
		int i, j, xflag = 0;
		for ( i = 0; ( i <= array.length - 2 ) && ( xflag == 0 ); i++ )
		{
			xflag = 1;
			for ( j = 0; j <= array.length - i - 2; j++ )
			{
				if ( array[j] > array[j + 1] )
				{
					swap(array, j, j + 1);
					xflag = 0;
				}
			}
		}
	}

	/* * * * * * * * * * 洫Ƨ * * * * * * * * * */

	public static void exchange_sort(int[] array)
	{
		int i, j;
		for ( i = 0; i <= array.length - 2; i++ )
		{
			for ( j = i + 1; j <= array.length - 1; j++ )
			{
				if ( array[i] > array[j] )
				{
					swap(array, i, j);
				}
			}
		}
	}

	/* * * * * * * * * * ܱƧ * * * * * * * * * */

	public static void select_sort(int[] array)
	{
		int i, j, small;
		for ( i = 0; i <= array.length - 2; i++ )
		{
			small = i;
			for ( j = i + 1; j <= array.length - 1; j++ )
			{
				if ( array[small] > array[j] )
				{
					small = j;
				}
			}
			swap(array, i, small);
		}
	}

	/* * * * * * * * * * JƧ * * * * * * * * * */

	public static void insert_sort(int[] array)
	{
		int i, j, x;
		for ( i = 1; i <= array.length - 1; i++ )
		{
			x = array[i];
			j = i - 1;
			while ( j >= 0 && array[j] > x )
			{
				array[j + 1] = array[j];
				j--;
			}
			array[j + 1] = x;
		}
	}

	/* * * * * * * * * * ºƧ * * * * * * * * * */

	public static void shell_sort(int[] array)
	{
		int i, j, x, hcount, hgroup;
		// hcount:CӸsժj
		for ( hcount = 2; hcount < ( array.length / 2 ); hcount = hcount * 2 )
		{
			// ӧOsէ@JƧ
			for ( hgroup = 1; hgroup <= hcount - 1; hgroup++ )
			{
				// JƧ
				for ( i = hgroup; i <= array.length - 1; i += hcount )
				{
					x = array[i];
					j = i - hcount;

					while ( j >= 0 && array[j] > x )
					{
						array[j + hcount] = array[j];
						j -= hcount;
					}

					array[j + hcount] = x;
				}
			}
		}

		// ̫A@@JƧ
		for ( i = 1; i <= array.length - 1; i++ )
		{
			x = array[i];
			j = i - 1;

			while ( j >= 0 && array[j] > x )
			{
				array[j + 1] = array[j];
				j--;
			}

			array[j + 1] = x;
		}
	}

	/* * * * * * * * * * ƱƧ * * * * * * * * * */

	public static void radix_sort(int[] array)
	{
		int i, j, k, index, no;

		// Ʀr}CƼȦsϪp
		int nocount[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

		// Ʀr}CƪȦs
		int noarray[][] = new int[10][array.length];

		for ( i = 0; i <= 2; i++ )
		{
			for ( j = 0; j <= 9; j++ )
			{
				nocount[j] = 0;
			}

			for ( j = 0; j <= array.length - 1; j++ )
			{
				// XƪƦr
				no = digitk(array[j], i);

				noarray[no][nocount[no]] = array[j];
				nocount[no] = nocount[no] + 1;
			}

			index = 0;
			// XUƦr}CƦ^A}C
			for ( j = 0; j <= 9; j++ )
			{
				for ( k = 0; k < nocount[j]; k++ )
				{
					array[index] = noarray[j][k];
					index++;
				}
			}
		}
	}

	// Ǧ^kƦr
	private static int digitk(int no, int kth)
	{
		int i, j, m = 0;
		if ( kth == 0 )
		{
			return no % 10;
		}
		else
		{
			for ( j = 0; j < kth; j++ )
			{
				if ( j == 0 )
				{
					m = 10;
				}
				else
				{
					m = m * 10;
				}
			}
			i = ( (int)( no / m ) ) % 10;
			return i;
		}
	}

	/* * * * * * * * * * ֳtƧ * * * * * * * * * */

	public static void quick_sort(int[] array, int left, int right)
	{
		int low, upper, point;

		if ( left < right )
		{
			point = array[left];
			low = left;
			upper = right + 1;

			while ( true )
			{
				while ( low < right && array[++low] < point ); // Vk
				while ( upper > left && array[--upper] > point ); // V
				if ( low >= upper ) break;
				swap(array, low, upper);
			}

			array[left] = array[upper];
			array[upper] = point;

			quick_sort(array, left, upper - 1); // 索i滼j
			quick_sort(array, upper + 1, right); // ki滼j
		}
	}

	public static void quick_sort(long[] array, int left, int right)
	{
		int low, upper;
		long point;

		if ( left < right )
		{
			point = array[left];
			low = left;
			upper = right + 1;

			while ( true )
			{
				while ( low < right && array[++low] < point ); // Vk
				while ( upper > left && array[--upper] > point ); // V
				if ( low >= upper ) break;
				swap(array, low, upper);
			}

			array[left] = array[upper];
			array[upper] = point;

			quick_sort(array, left, upper - 1); // 索i滼j
			quick_sort(array, upper + 1, right); // ki滼j
		}
	}

	/* * * * * * * * * * XֱƧ * * * * * * * * * */

	public static void merge_sort(int[] array, int left, int right)
	{
		int half;
		if ( left < right )
		{
			// 䤤m
			half = ( left + right ) / 2;
			// N줤@bƦC@Ƨ
			merge_sort(array, left, half);
			// Nk䪺@bƦC@Ƨ
			merge_sort(array, half + 1, right);
			// NkӼƦCX
			merge(array, left, array, left, half, array, half + 1, right);
		}
	}

	// X֤GӤlƦCX֦sƦCmergetk
	private static void merge(int A1[], int A1_start, int A2[], int A2_start, int A2_end, int A3[], int A3_start,
			int A3_end)
	{
		int i, j, k = 0, h;
		int B[] = new int[A1.length]; // Ȧs}C

		i = A2_start;
		j = A3_start;

		while ( i <= A2_end && j <= A3_end )
		{
			if ( A2[i] <= A3[j] ) B[k++] = A2[i++];
			else B[k++] = A3[j++];
		}

		while ( i <= A2_end )
		{
			B[k++] = A2[i++];
		}
		while ( j <= A3_end )
		{
			B[k++] = A3[j++];
		}
		// NȦs}CƨXs쥻}C
		for ( h = 0; h < k; h++ )
		{
			A1[A1_start + h] = B[h];
		}
	}
}
