import java.io.*;

public class SortingAlgorithms extends Algorithms
{

	public static void main(String[] args)
	{
		int minLevel, maxLevel;
		int minKey, maxKey;

		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

		SortMethod method;

		try
		{
			do
			{
				System.out.printf("Sorting Algorithms:\n  All, Bubble, Exchange, "
						+ "Selection, Insertion, Radix, Shell, Quick, Merge\n" + "please switch one: ");
				String s = br.readLine();
				if ( s.equalsIgnoreCase("all") ) method = SortMethod.SORT_ALL;
				else if ( s.equalsIgnoreCase("bubble") ) method = SortMethod.SORT_BUBBLE;
				else if ( s.equalsIgnoreCase("exchange") ) method = SortMethod.SORT_EXCHANGE;
				else if ( s.equalsIgnoreCase("selection") ) method = SortMethod.SORT_SELECT;
				else if ( s.equalsIgnoreCase("insertion") ) method = SortMethod.SORT_INSERT;
				else if ( s.equalsIgnoreCase("radix") ) method = SortMethod.SORT_RADIX;
				else if ( s.equalsIgnoreCase("shell") ) method = SortMethod.SORT_SHELL;
				else if ( s.equalsIgnoreCase("quick") ) method = SortMethod.SORT_QUICK;
				else if ( s.equalsIgnoreCase("Merge") ) method = SortMethod.SORT_MERGE;
				else method = null;
			}
			while ( method == null );

			do
			{
				try
				{
					System.out.printf("input the min-level of key count(2^n): ");
					minLevel = Integer.parseInt(br.readLine());
				}
				catch ( NumberFormatException e )
				{
					minLevel = -1;
				}
			}
			while ( minLevel < 0 );

			do
			{
				try
				{
					System.out.printf("input the max-level of key count(2^n): ");
					maxLevel = Integer.parseInt(br.readLine());
				}
				catch ( NumberFormatException e )
				{
					maxLevel = -1;
				}
			}
			while ( maxLevel < minLevel );

			do
			{
				try
				{
					System.out.printf("input the min-level of key number(2^n): ");
					minKey = Integer.parseInt(br.readLine());
				}
				catch ( NumberFormatException e )
				{
					minKey = -1;
				}
			}
			while ( minKey < 0 );

			do
			{
				try
				{
					System.out.printf("input the max-level of key number(2^n): ");
					maxKey = Integer.parseInt(br.readLine());
				}
				catch ( NumberFormatException e )
				{
					maxKey = -1;
				}
			}
			while ( maxKey < minKey );

			if ( method == SortMethod.SORT_ALL )
			{
				SortMethod[] methods = SortMethod.values();
				for ( int i = 0; i < methods.length; i++ )
				{
					if ( methods[i] != SortMethod.SORT_ALL )
					{
						test(methods[i], minLevel, maxLevel, minKey, maxKey);
					}
				}
			}
			else
			{
				test(method, minLevel, maxLevel, minKey, maxKey);
			}
			System.out.printf("finished.\n");
		}
		catch ( IOException e )
		{
			System.out.printf("I/O ERROR\n");
		}
	}

	public static void test(SortMethod method, int minLevel, int maxLevel, int minKey, int maxKey) throws IOException
	{
		final int sizeofInt = 4;
		long[][][] times = new long[maxLevel - minLevel + 1][maxKey - minKey + 1][9];

		System.out.printf("using %s sort the array length from 2^%d to 2^%d number from 2^%d to 2^%d\n", method.name(),
				minLevel, maxLevel, minKey, maxKey);

		// process time table
		System.out.printf("processing time table\n");
		System.out.printf("%9s%9s", "LEN\\NUM", "MEM(KB)");
		for ( int key = minKey; key <= maxKey; key++ )
		{
			System.out.printf("%9d", key);
		}
		System.out.printf("\n");

		for ( int level = minLevel; level <= maxLevel; level++ )
		{
			System.out.printf("%9d%9d", level, (int)Math.pow(2, level) * sizeofInt / 1024);
			for ( int key = minKey; key <= maxKey; key++ )
			{
				for ( int i = 0; i < times[level - minLevel][key - minKey].length; i++ )
				{
					int[] array = randomArray((int)Math.pow(2, level), (int)Math.pow(2, key));
					times[level - minLevel][key - minKey][i] = sort(array, method);
					System.out.printf("#");
				}
				quick_sort(times[level - minLevel][key - minKey], 0, times[level - minLevel][key - minKey].length - 1);
			}
			System.out.printf("\n");
		}
		System.out.printf("\n");

		// output result

		FileWriter fw = new FileWriter(method.name() + ".log");

		// minTime
		System.out.printf("min-time table\n%9s%9s", "LEN\\NUM", "MEM(KB)");
		fw.write(String.format("min-time table\n%9s%9s", "LEN\\NUM", "MEM(KB)"));
		for ( int key = minKey; key <= maxKey; key++ )
		{
			System.out.printf("%9d", key);
			fw.write(String.format("%9d", key));
		}
		System.out.printf("\n");
		fw.write("\n");

		for ( int level = minLevel; level <= maxLevel; level++ )
		{
			System.out.printf("%9d%9d", level, (int)Math.pow(2, level) * sizeofInt / 1024);
			fw.write(String.format("%9d%9d", level, (int)Math.pow(2, level) * sizeofInt / 1024));
			for ( int key = minKey; key <= maxKey; key++ )
			{
				long minTime = times[level - minLevel][key - minKey][0];
				System.out.printf("%9d", minTime);
				fw.write(String.format("%9d", minTime));
			}
			System.out.printf("\n");
			fw.write("\n");
		}
		System.out.printf("\n");
		fw.write("\n");

		// maxTime
		System.out.printf("max-time table\n%9s%9s", "LEN\\NUM", "MEM(KB)");
		fw.write(String.format("max-time table\n%9s%9s", "LEN\\NUM", "MEM(KB)"));
		for ( int key = minKey; key <= maxKey; key++ )
		{
			System.out.printf("%9d", key);
			fw.write(String.format("%9d", key));
		}
		System.out.printf("\n");
		fw.write("\n");

		for ( int level = minLevel; level <= maxLevel; level++ )
		{
			System.out.printf("%9d%9d", level, (int)Math.pow(2, level) * sizeofInt / 1024);
			fw.write(String.format("%9d%9d", level, (int)Math.pow(2, level) * sizeofInt / 1024));
			for ( int key = minKey; key <= maxKey; key++ )
			{
				long maxTime = times[level - minLevel][key - minKey][8];
				System.out.printf("%9d", maxTime);
				fw.write(String.format("%9d", maxTime));
			}
			System.out.printf("\n");
			fw.write("\n");
		}
		System.out.printf("\n");
		fw.write("\n");

		// avgTime
		System.out.printf("avg-time table\n%9s%9s", "LEN\\NUM", "MEM(KB)");
		fw.write(String.format("avg-time table\n%9s%9s", "LEN\\NUM", "MEM(KB)"));
		for ( int key = minKey; key <= maxKey; key++ )
		{
			System.out.printf("%9d", key);
			fw.write(String.format("%9d", key));
		}
		System.out.printf("\n");
		fw.write("\n");

		for ( int level = minLevel; level <= maxLevel; level++ )
		{
			System.out.printf("%9d%9d", level, (int)Math.pow(2, level) * sizeofInt / 1024);
			fw.write(String.format("%9d%9d", level, (int)Math.pow(2, level) * sizeofInt / 1024));
			for ( int key = minKey; key <= maxKey; key++ )
			{
				long sumTime = 0;
				for ( int i = 0; i < times[level - minLevel][key - minKey].length; i++ )
				{
					sumTime += times[level - minLevel][key - minKey][i];
				}
				long avgTime = sumTime / times[level - minLevel][key - minKey].length;
				System.out.printf("%9d", avgTime);
				fw.write(String.format("%9d", avgTime));
			}
			System.out.printf("\n");
			fw.write("\n");
		}
		System.out.printf("\n");
		fw.write("\n");

		System.out.printf("result saved to %s.log\n\n", method.name());
		fw.close();
	}

	public static enum SortMethod
	{
		SORT_ALL, SORT_BUBBLE, SORT_EXCHANGE, SORT_SELECT, SORT_INSERT, SORT_SHELL, SORT_RADIX, SORT_QUICK, SORT_MERGE
	}

	public static long sort(int[] array, SortMethod method)
	{
		long time = System.currentTimeMillis();
		switch ( method )
		{
			case SORT_BUBBLE:
				bubble_sort(array);
				break;
			case SORT_EXCHANGE:
				exchange_sort(array);
				break;
			case SORT_SELECT:
				select_sort(array);
				break;
			case SORT_INSERT:
				insert_sort(array);
				break;
			case SORT_SHELL:
				shell_sort(array);
				break;
			case SORT_RADIX:
				radix_sort(array);
				break;
			case SORT_QUICK:
				quick_sort(array, 0, array.length - 1);
				break;
			case SORT_MERGE:
				merge_sort(array, 0, array.length - 1);
				break;
			default:
				break;
		}
		return System.currentTimeMillis() - time;
	}

	// create array with random value
	public static int[] randomArray(int element_count, int max_value)
	{
		int[] array = new int[element_count];
		for ( int i = 0; i < array.length; i++ )
		{
			array[i] = (int)( Math.random() * max_value );
		}
		return array;
	}

	// convert array to string or
	// output array
	public static void printArray(int[] array, int max_value)
	{
		String format = String.format("%%0%dd ", (int)Math.ceil(Math.log10(max_value)));
		int line_length = 16;
		int line_count = array.length / line_length;
		for ( int i = 0; i < line_count; i++ )
		{
			for ( int j = 0; j < line_length; j++ )
			{
				// result += String.format(format, array[i * line_length + j]);
				System.out.print(String.format(format, array[i * line_length + j]));
			}
			// result += "\n";
			System.out.println();
		}
		if ( ( array.length % line_length ) > 0 )
		{
			for ( int i = 0; i < ( array.length % line_length ); i++ )
			{
				// result += String.format(format, array[line_count *
				// line_length
				// + i]);
				System.out.print(String.format(format, array[line_count * line_length + i]));
			}
			// result += "\n";
			System.out.println();
		}
		// return result;
	}

}
